// Generic Commander class
// Owns one or more ships and one or more targets
// during 'oneStep' moves all its ships against
// as many of its targets as possible

#import <appkit/appkit.h>
#import "xoxDefs.h"
@interface Commander:Object
{
	List* ships;
	List* targets;
	ALLIANCE alliance;
}

// initialize & destroy variables
- init;
- free;

// add a ship or target to be responsible for
- addShip:ship;
- addTarget:target;

// give all your ships and targets to someone else
- transferTo:commander;

// Do nothing; overriden by subclasses
- oneStep:scenario;

// Does nothing; used by subclasses
- reset;
- resetShip:ship;
@end
