// Scenario module for XoxWars
// Manages Computer Commanders

#import <appkit/appkit.h>
#import "Scenario.h"
#import "ActorMgr.h"

extern float xw_gravity;
extern int xw_bulletSpeed, xw_bounce;

@interface XoxWars:Object <Scenario>
{
	id goodShip;
	id badShip;
	id space;
	int goToNextLevel;
	int explosionCount;

	id infoView;
	id scoreView;
	int goodBullets;
	int badBullets;
	id sun;

	id gravityMatrix;
	id bulletMatrix;
	id settingsMatrix;
	id meteorsSlider;
	id difficultySlider;

	id dartButton;
	id dartKillsText;
	id clawButton;
	id clawKillsText;
	int dartKills;
	int clawKills;
	id uselessBox;

	id commanders;
	id playerBox;
	id playerClasses;
}

- (int) bullets : (int) type;
- (BOOL) hasBullets : (int) type;

- adjustSettings:sender;

- initPlayers;

// Methods for adding computer players
- loadPlayers;
- setPlayers;

// action method called by popup buttons
- changePlayer:sender;

// move the computer players
- oneStep;

@end

@interface Actor(XoxWarsAdditions)
- swApplyGravity;
@end


@interface ActorMgr(XoxWarsAdditions)
- listFor:(ALLIANCE)alliance;
@end
